﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;
using System.Xml;
namespace test
{
    public partial class frmKML : Form
    {
        public frmKML()
        {
            InitializeComponent();
        }

        private void frmKML_Load(object sender, EventArgs e)
        {
            LoadDefaultMap();
            PlotKML();
            //KmlFeatureLayer layer = new KmlFeatureLayer(Application.StartupPath + @"\\Data\\VT-BDN_29-Aug-2014_BOM-DEL.kml");
           
            //KmlFeatureLayer kml = new KmlFeatureLayer(Application.StartupPath +"\\Data\\VT-BDN_29-Aug-2014_BOM-DEL\\VT-BDN_29-Aug-2014_BOM-DEL.kml");
            //PlotEEP();
        }
        private void PlotEEP()
        {
            InMemoryFeatureLayer impoint = new InMemoryFeatureLayer();
            impoint.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.Red), 3);

            Feature f1 = new Feature(new Vertex(-71,45));
            Feature f2 = new Feature(new Vertex(-70,50));

            EllipseShape el = new EllipseShape(f1, 152, GeographyUnit.DecimalDegree, DistanceUnit.NauticalMile);
            Feature fel = new Feature(el);

            Feature fline = new Feature(BaseShape.CreateShapeFromWellKnownData("LINESTRING(-71 45,-70 50)"));

            PointShape p1 = new PointShape(f1.GetWellKnownText());
            LineShape line = new LineShape(fline.GetWellKnownText());
            PointShape Pmid = line.GetPointOnALine(StartingPoint.FirstPoint, 152, GeographyUnit.Meter, DistanceUnit.NauticalMile);

            MultipointShape mp1 = line.GetCrossing(el);
            Feature  mp =  fel.GetIntersection(fline);


            }
        private void PlotKML()
        {
            try
            {
               // KmlFeatureLayer layer = new KmlFeatureLayer("D:\\EUM.kml");
                KmlLayer kmllayer = new KmlLayer(Application.StartupPath+@"\\Data\\doc.kml");
               
                LayerOverlay overlay = new LayerOverlay();
                overlay.Layers.Add(kmllayer);
                winformsMap1.Overlays.Add(overlay);
                kmllayer.Open();

                winformsMap1.CurrentExtent = kmllayer.GetBoundingBox();
                winformsMap1.Refresh(); 
              //  KmlFeatureLayer layer = new KmlFeatureLayer("C:\\Users\\goral\\Downloads\\Jalahalli\\Jalahalli.kml");
                //layer. = "Landmark";
                //layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Black), new GeoSolidBrush(GeoColor.SimpleColors.Yellow));
                //layer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.SimpleColors.Blue, 5));
                //layer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.Green), 10);
                //layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                //LayerOverlay stateOverlay = new LayerOverlay();
                //stateOverlay.Layers.Add("KmlLayer", layer);
                //winformsMap1.Overlays.Add("StateOverlay", stateOverlay);
                //winformsMap1.Refresh();
                
              //  KmlFeatureSource kml = new KmlFeatureSource("C:\\Users\\goral\\Downloads\\Jalahalli\\Jalahalli.kml");
            
              // //// Collection<Feature> f2 = layer.
               
              ////  List<Feature> f = layer.FeatureSource.GetAllFeatures().ToList();
              //  IEnumerable<FeatureSourceColumn> fc = layer.FeatureSource.GetColumns().ToList();
                
              //  InMemoryFeatureLayer im = new InMemoryFeatureLayer();
                
              //  //im.Columns.Add(new FeatureSourceColumn("1"));
              //  //im.Columns.Add(new FeatureSourceColumn("2"));
              //  //im.Columns.Add(new FeatureSourceColumn("name"));
                    
                   
             
              //  //im = new InMemoryFeatureLayer(fc, f);
              //  //im.FeatureSource.Open();
              // // MessageBox.Show(im.InternalFeatures[0].ColumnValues["name"].ToString());
              // // Collection<Feature> f1 = layer.FeatureSource.GetFeaturesByColumnValue("name","Dena Bank");
            }
            catch (Exception er)
            {
                MessageBox.Show(er.ToString());
            }
        }
        private void LoadDefaultMap()
        {
           
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);
       
            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\countryfinal.shp");
            worldLayer.RequireIndex = false;
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            LayerOverlay coverlay = new LayerOverlay();


            coverlay.Layers.Add("CountryLayer", worldLayer);
            winformsMap1.Overlays.Add(coverlay);


            
            winformsMap1.Refresh();

        }
    }
}
